package com.chinaitop.depot.intelligent.grainsituation.model;

import java.util.ArrayList;
import java.util.List;

public class TActkindExample {
    /**
     * t_actkind
     */
    protected String orderByClause;

    /**
     * t_actkind
     */
    protected boolean distinct;

    /**
     * t_actkind
     */
    protected List<Criteria> oredCriteria;

    public TActkindExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * t_actkind 2018-11-06
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeIsNull() {
            addCriterion("vDevKindCode is null");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeIsNotNull() {
            addCriterion("vDevKindCode is not null");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeEqualTo(String value) {
            addCriterion("vDevKindCode =", value, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeNotEqualTo(String value) {
            addCriterion("vDevKindCode <>", value, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeGreaterThan(String value) {
            addCriterion("vDevKindCode >", value, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeGreaterThanOrEqualTo(String value) {
            addCriterion("vDevKindCode >=", value, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeLessThan(String value) {
            addCriterion("vDevKindCode <", value, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeLessThanOrEqualTo(String value) {
            addCriterion("vDevKindCode <=", value, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeLike(String value) {
            addCriterion("vDevKindCode like", value, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeNotLike(String value) {
            addCriterion("vDevKindCode not like", value, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeIn(List<String> values) {
            addCriterion("vDevKindCode in", values, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeNotIn(List<String> values) {
            addCriterion("vDevKindCode not in", values, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeBetween(String value1, String value2) {
            addCriterion("vDevKindCode between", value1, value2, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeNotBetween(String value1, String value2) {
            addCriterion("vDevKindCode not between", value1, value2, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindnameIsNull() {
            addCriterion("vDevKindName is null");
            return (Criteria) this;
        }

        public Criteria andVdevkindnameIsNotNull() {
            addCriterion("vDevKindName is not null");
            return (Criteria) this;
        }

        public Criteria andVdevkindnameEqualTo(String value) {
            addCriterion("vDevKindName =", value, "vdevkindname");
            return (Criteria) this;
        }

        public Criteria andVdevkindnameNotEqualTo(String value) {
            addCriterion("vDevKindName <>", value, "vdevkindname");
            return (Criteria) this;
        }

        public Criteria andVdevkindnameGreaterThan(String value) {
            addCriterion("vDevKindName >", value, "vdevkindname");
            return (Criteria) this;
        }

        public Criteria andVdevkindnameGreaterThanOrEqualTo(String value) {
            addCriterion("vDevKindName >=", value, "vdevkindname");
            return (Criteria) this;
        }

        public Criteria andVdevkindnameLessThan(String value) {
            addCriterion("vDevKindName <", value, "vdevkindname");
            return (Criteria) this;
        }

        public Criteria andVdevkindnameLessThanOrEqualTo(String value) {
            addCriterion("vDevKindName <=", value, "vdevkindname");
            return (Criteria) this;
        }

        public Criteria andVdevkindnameLike(String value) {
            addCriterion("vDevKindName like", value, "vdevkindname");
            return (Criteria) this;
        }

        public Criteria andVdevkindnameNotLike(String value) {
            addCriterion("vDevKindName not like", value, "vdevkindname");
            return (Criteria) this;
        }

        public Criteria andVdevkindnameIn(List<String> values) {
            addCriterion("vDevKindName in", values, "vdevkindname");
            return (Criteria) this;
        }

        public Criteria andVdevkindnameNotIn(List<String> values) {
            addCriterion("vDevKindName not in", values, "vdevkindname");
            return (Criteria) this;
        }

        public Criteria andVdevkindnameBetween(String value1, String value2) {
            addCriterion("vDevKindName between", value1, value2, "vdevkindname");
            return (Criteria) this;
        }

        public Criteria andVdevkindnameNotBetween(String value1, String value2) {
            addCriterion("vDevKindName not between", value1, value2, "vdevkindname");
            return (Criteria) this;
        }

        public Criteria andVremarkIsNull() {
            addCriterion("vRemark is null");
            return (Criteria) this;
        }

        public Criteria andVremarkIsNotNull() {
            addCriterion("vRemark is not null");
            return (Criteria) this;
        }

        public Criteria andVremarkEqualTo(String value) {
            addCriterion("vRemark =", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkNotEqualTo(String value) {
            addCriterion("vRemark <>", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkGreaterThan(String value) {
            addCriterion("vRemark >", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkGreaterThanOrEqualTo(String value) {
            addCriterion("vRemark >=", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkLessThan(String value) {
            addCriterion("vRemark <", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkLessThanOrEqualTo(String value) {
            addCriterion("vRemark <=", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkLike(String value) {
            addCriterion("vRemark like", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkNotLike(String value) {
            addCriterion("vRemark not like", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkIn(List<String> values) {
            addCriterion("vRemark in", values, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkNotIn(List<String> values) {
            addCriterion("vRemark not in", values, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkBetween(String value1, String value2) {
            addCriterion("vRemark between", value1, value2, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkNotBetween(String value1, String value2) {
            addCriterion("vRemark not between", value1, value2, "vremark");
            return (Criteria) this;
        }
    }

    /**
     * t_actkind
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * t_actkind 2018-11-06
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}